function AutoLootAssist_OnLoad(self)
    self:RegisterEvent("UNIT_AURA");
    self:RegisterEvent("UNIT_SPELLCAST_SENT");
end


function AutoLootAssist_OnEvent(self, event, ...)
    if event == "LOOT_READY" then
        self:UnregisterEvent("LOOT_READY");
        if self.LastAuraInstanceID or AutoLootAssist_IsSpellRelevant(self.LastSpellID) then
            for i = 1, GetNumLootItems() do
                LootSlot(i);
            end
        end
    elseif event == "UNIT_AURA" then
        local unitTarget, updatedAuras = ...;
        if unitTarget == "player" then
            -- Ice Fishing
            if updatedAuras.addedAuras then
                for _, aura in ipairs(updatedAuras.addedAuras) do
                    if aura.spellId == 377895 then 
                        self.LastAuraInstanceID = aura.auraInstanceID;
                        self:RegisterEvent("LOOT_READY");
                    end
                end
            end
            if updatedAuras.removedAuraInstanceIDs then
                for _, auraID in ipairs(updatedAuras.removedAuraInstanceIDs) do
                    if auraID == self.LastAuraInstanceID then
                        C_Timer.After(1, function() self.LastAuraInstanceID = nil; self:UnregisterEvent("LOOT_READY"); end);
                    end
                end
            end
        end
    elseif event == "UNIT_SPELLCAST_SENT" then
        local _, _, _, spellID = ...;
        if AutoLootAssist_IsSpellRelevant(spellID) then
            self.LastSpellID = spellID;
            self:RegisterEvent("LOOT_READY");
        else
            self.LastSpellID = nil;
        end
    end
end


function AutoLootAssist_IsSpellRelevant(spellID)
    return spellID == 921 -- Pick Pocket
        or spellID == 13262 -- Disenchant
        or spellID == 131474; -- Fishing
end
